

;-----------------------------------------------------------------------------
; A little shell
; This shell is also from the PlusShell package from Rusty Wagner
; adapted by 	TriX
; released by	MXM Projects
;-----------------------------------------------------------------------------

; Sorry, it's not well documented yet
; This shell is similar to the Fargo shell

        include "util.h"
        include "doorsos.h"

        xdef _main
        xdef _comment
        xdef _ti92plus
;	xdef _ti92		I hope this will work soon :-(

_main:
        move.w #1,textfont
        move.w #8,textheight
        move.w #2,titlefont
        move.w #16,titleheight
        move.w #54,namewidth
        move.w #8,fontwidth
        move.w #240,_LCD_WIDTH
        move.w #128,_LCD_HEIGHT
calctestdone:
        move.w #$B,currentfolder
        move.w #0,infolder
        move.w #0,first
        move.w #12,last
        bsr DrawFolder
        bsr Select
        rts

DrawFolder:
        move.w _LCD_HEIGHT,-(a7)
        sub.w #8,(a7)
        move.w _LCD_WIDTH,-(a7)
        sub.w #1,(a7)
        move.w #0,-(a7)
        move.w #0,-(a7)
        jsr util::erase_rect
        add.l #8,a7
        move.w titlefont,-(a7)
        jsr doorsos::FontSetSys
        add.l #2,a7
        move.w titleheight,-(a7)
        move.w _LCD_WIDTH,-(a7)
        sub.w #1,(a7)
        move.w #0,-(a7)
        move.w #0,-(a7)
        jsr util::frame_rect
        add.l #8,a7
        move.w _LCD_HEIGHT,-(a7)
        sub.w #7,(a7)
        move.w namewidth,-(a7)
        move.w titleheight,-(a7)
        move.w #0,-(a7)
        jsr util::frame_rect
        add.l #8,a7
        move.w _LCD_HEIGHT,-(a7)
        sub.w #7,(a7)
        move.w _LCD_WIDTH,-(a7)
        sub.w #1,(a7)
        move.w titleheight,-(a7)
        move.w namewidth,-(a7)
        jsr util::frame_rect
        add.l #8,a7
        move.w #2,-(a7)
        move.l #shellname,-(a7)
        move.w #4,-(a7)
        move.w #4,-(a7)
        jsr doorsos::DrawStrXY
        add.l #10,a7
        move.l #version,-(a7)
        jsr doorsos::strlen
        add.l #4,a7
        move.w #2,-(a7)
        move.l #version,-(a7)
        move.w #4,-(a7)
        mulu.w fontwidth,d0
        move.w _LCD_WIDTH,d1
        sub.w #4,d1
        sub.w d0,d1
        move.w d1,-(a7)
        jsr doorsos::DrawStrXY
        add.l #10,a7
        move.w textfont,-(a7)
        jsr doorsos::FontSetSys
        add.l #2,a7

        move.w currentfolder,d0
        doorsos::DEREF d0,a0
        move.w 2(a0),d7
        add.l #4,a0
        move.l #name,a1
        move.w titleheight,d0
        add.w #1,d0
        move.w d0,y
        clr.w count
        move.l #handlelist,a3
dfLoop:
        tst.w d7
        beq dfEnd
        clr.w flags
	cmp.b  #'0',(a0)			; Skip 000x folders
	beq    dfNext	
	cmp.l  #'shel',(a0)
	bne    NoShell
	cmp.l  #$6b000000,4(a0)
	beq    dfNext 
NoShell:
        move.l (a0),(a1)
        move.l 4(a0),4(a1)
        tst.w infolder
        beq dfDrawName
        move.w 10(a0),d0
        doorsos::DEREF d0,a2
        clr.l d0
        move.w (a2),d0
        move.l a2,a4
        add.l d0,a4
        add.l #1,a4
        move.b (a4),d0
        add.l #2,a2

        move.l 4(a2),d0
        and.l #$ffffff00,d0
        cmp.l #$36386b00,d0 ; '68k'
        bne dfDrawName

checkdone:
        cmp.b #'P',7(a2)
        beq dfSkipLibCheck
        cmp.b #'L',7(a2)
        beq dfNext
dfSkipLibCheck:
        clr.l d0
        move.w 10(a2),d0
doCommentCheck:
        tst.w d0
        beq dfDrawName
        add.l d0,a2
doComment:
        move.b (a2),d0
        cmp.b #'^',d0
        beq dfNext
        move.w count,d0
        move.w first,d1
        add.w #1,count
        cmp.w d1,d0
        blt dfNext
        move.w last,d1
        cmp.w d1,d0
        bgt dfNext
        sub.w #1,count
        movem.l d7/a0-a3,-(a7)
        move.w #2,-(a7)
        move.l a2,-(a7)
        move.w y,d0
        move.w d0,-(a7)
        move.w namewidth,-(a7)
        add.w #2,(a7)
        jsr doorsos::DrawStrXY
        add.l #10,a7
        movem.l (a7)+,d7/a0-a3
dfDrawName:
        move.w count,d0
        move.w first,d1
        add.w #1,count
        cmp.w d1,d0
        blt dfNext
        move.w last,d1
        cmp.w d1,d0
        bgt dfNext
        movem.l d7/a0-a3,-(a7)
        move.w #2,-(a7)
        move.l a1,-(a7)
        move.w y,d0
        move.w d0,-(a7)
        move.w #2,-(a7)
        jsr doorsos::DrawStrXY
        add.l #10,a7
        movem.l (a7)+,d7/a0-a3
        move.w 10(a0),d0
        or.w flags,d0
        move.w d0,(a3)+
        move.w textheight,d0
        add.w d0,y
dfNext:
        move.l #handlelist,a3
        clr.l d0
        move.w count,d0
        lsl.l #1,d0
        add.l d0,a3
        add.l #$c,a0
        dbra d7,dfLoop
dfEnd:
        rts

Select:
        move.w #0,sel
SelLoop:
        bsr InvertSel
        jsr util::idle_loop
        bsr InvertSel
        cmp.w #338,d0
        beq slUp
        cmp.w #344,d0
        beq slDown
        cmp.w #13,d0
        beq slEnter
        cmp.w #264,d0
        beq slEsc
	cmp.w #268,d0
	bne SelLoop 	

	move.w 	#1,-(a7)
	jsr	doorsos::FontSetSys
	lea	2(a7),a7

        move.l #AboutDialog,a6
        jsr util::show_dialog
        jsr util::idle_loop
        jsr util::clear_dialog
	bsr DrawFolder
	bra SelLoop

slUp:
        cmp.w #0,sel
        beq SelLoop
        sub.w #1,sel
        move.w sel,d0
        move.w first,d1
        cmp.w d1,d0
        bge SelLoop
        sub.w #1,first
        sub.w #1,last
        bsr DrawFolder
        bra SelLoop
slDown:
        tst.w count
        beq SelLoop
        add.w #1,sel
        move.w count,d0
        move.w sel,d1
        cmp.w d0,d1
        blt slCheckLast
        sub.w #1,sel
slCheckLast:
        move.w sel,d0
        move.w last,d1
        cmp.w d1,d0
        ble SelLoop
        add.w #1,first
        add.w #1,last
        bsr DrawFolder
        bra SelLoop
slEnter:
        tst.w count
        beq SelLoop
        move.l #handlelist,a0
        clr.l d0
        move.w sel,d0
        lsl.w #1,d0
        add.l d0,a0
        move.w (a0),d0
        move.w d0,-(a7)
        cmp.w #$ffff,d0
        bne slNotIncompat
        move.l #notcompatDialog,a6
        jsr util::show_dialog
        jsr util::idle_loop
        jsr util::clear_dialog
        bsr DrawFolder
        move.w (a7)+,d0
        bra SelLoop
slNotIncompat:
        move.w d0,d1
        and.w #$8000,d1
        beq slNot89Warn
        move.l #overrideDialog,a6
        jsr util::show_dialog
slOverrideLoop:
        jsr util::idle_loop
        cmp.w #13,d0
        beq overrideContinue
        cmp.w #264,d0
        bne slOverrideLoop
        jsr util::clear_dialog
        bsr DrawFolder
        move.w (a7)+,d0
        bra SelLoop
overrideContinue:
        jsr util::clear_dialog

        bra slNot92Warn
slNot89Warn:
        move.w d0,d1
        and.w #$4000,d1
        beq slNot92Warn
        move.l #warn89emuDialog,a6
        jsr util::show_dialog
sl89emuLoop:
        jsr util::idle_loop
        cmp.w #13,d0
        beq emu89Continue
        cmp.w #264,d0
        bne sl89emuLoop
        jsr util::clear_dialog
        bsr DrawFolder
        move.w (a7)+,d0
        bra SelLoop
emu89Continue:
        jsr util::clear_dialog
slNot92Warn:
        move.w (a7)+,d0
        tst.w infolder
        beq slEnterFolder
        

	move.l ($34),a0
        jsr (a0)                       ; execute program

continueAfterError:
        tst.l d0
        bne slExecError
        jsr doorsos::ST_eraseHelp
slExecError:
        bsr DrawFolder
        bra SelLoop
slEnterFolder:
        move.w d0,currentfolder
        move.w #1,infolder
        move.w #0,first
        move.w #12,last
        bsr DrawFolder
        bsr Select
        move.w #$b,currentfolder
        move.w #0,infolder
        move.w #0,first
        move.w #12,last
        bsr DrawFolder
        move.w #0,sel
        bra SelLoop
slEsc:
        rts

errorInExec:
        move.l handlecount,d1
        move.l #handlelist,a0
eieDelLoop:
        tst.l d1
        beq eieDispErr
        move.w (a0)+,d2
        tst.w d2
        beq eieNext
        movem.l d0-d1/a0,-(a7)
        move.w d2,-(a7)
        jsr doorsos::HeapFree
        add.l #2,a7
        movem.l (a7)+,d0-d1/a0
eieNext:
        dbra d1,eieDelLoop
eieDispErr:
        clr.l d0
        trap #1
        move.l #1,d0
        bra continueAfterError

InvertSel:
        move.l d0,-(a7)
        move.l #LCD_MEM,a0
        move.w sel(pc),d0
        sub.w first(pc),d0
        mulu.w textheight,d0
        add.w titleheight,d0
        add.w #1,d0
        mulu.w #30,d0
        add.l d0,a0
        clr.l d0
        move.w textheight,d0
        sub.l #1,d0
eorloop:
        eor.b #$7f,(a0)
        eor.b #$ff,1(a0)
        eor.b #$ff,2(a0)
        eor.b #$ff,3(a0)
        eor.b #$ff,4(a0)
        eor.b #$ff,5(a0)
        eor.b #$fc,6(a0)
        add.l #30,a0
        dbra d0,eorloop
        move.l (a7)+,d0
        rts
eorloop89:
        eor.b #$7f,(a0)
        eor.b #$ff,1(a0)
        eor.b #$ff,2(a0)
        eor.b #$ff,3(a0)
        eor.b #$ff,4(a0)
        add.l #30,a0
        dbra d0,eorloop89
        move.l (a7)+,d0
        rts



newHeapAlloc:
        move.l oldROMTable,a0
        move.l $240(a0),a0
        move.l 4(a7),a1
        move.l a1,-(a7)
        jsr (a0)
        add.l #4,a7
        move.l #handlelist,a0
        move.l handlecount,d1
        lsl.l #1,d1
        add.l d1,a0
        move.w d0,(a0)
        add.l #1,handlecount
        rts

newHeapAllocThrow:
        move.l oldROMTable,a0
        move.l $24c(a0),a0
        move.l 4(a7),a1
        move.l a1,-(a7)
        jsr (a0)
        add.l #4,a7
        move.l #handlelist,a0
        move.l handlecount,d1
        lsl.l #1,d1
        add.l d1,a0
        move.w d0,(a0)
        add.l #1,handlecount
        rts

newHeapFree:
        move.w 4(a7),d0
        move.l handlecount,d1
        move.l #handlelist,a0
nhfFindLoop:
        tst.l d1
        beq nhfCallOld
        move.w (a0)+,d1
        cmp.w d0,d1
        beq nhfDelMe
        dbra d1,nhfFindLoop
        bra nhfCallOld
nhfDelMe:
        sub.l #2,a0
        clr.w (a0)
nhfCallOld:
        move.l oldROMTable,a0
        move.l $25c(a0),a0
        jmp (a0)

newHeapFreeIndir:
        move.l 4(a7),a0
        move.w (a0),d0
        move.l handlecount,d1
        move.l #handlelist,a0
nhfiFindLoop:
        tst.l d1
        beq nhfiCallOld
        move.w (a0)+,d1
        cmp.w d0,d1
        beq nhfiDelMe
        dbra d1,nhfiFindLoop
        bra nhfiCallOld
nhfiDelMe:
        sub.l #2,a0
        clr.w (a0)
nhfiCallOld:
        move.l oldROMTable,a0
        move.l $260(a0),a0
        jmp (a0)

newERThrow:
        dc.w $a000

newTrap1:
        and.w #$700,d0
        cmp.w #$600,d0
        blt doTrap1
        move.w #$600,d0
doTrap1:
        move.l oldVect+$48,-(a7)
        rts


delay:
        nop
        nop
        nop
        nop
        nop
        nop
        rts

checkTerminate:
        move.w #$fffe,$600018
        bsr delay
        bsr delay
        bsr delay

noTerminate:
        move.l oldVect+$38,-(a7)
        rts


textfont dc.w 1
textheight dc.w 8
titlefont dc.w 2
titleheight dc.w 16
namewidth dc.w 54
fontwidth dc.w 0
_LCD_WIDTH dc.w 240
_LCD_HEIGHT dc.w 128

;emu89 dc.w 0

y dc.w 0
infolder dc.w 0
currentfolder dc.w 8
count dc.w 0
name dc.l 0,0,0
sel dc.w 0
shellname dc.b "[tie] browser",0
version dc.b "v0.3",128,0
null dc.l 0
first dc.w 0
last dc.w 12
_comment dc.b "^",0 ; '^' marks program as hidden

terminateMsg dc.b "Terminated by User",0
throwMsg dc.b "Unknown Error",0
enable89emu dc.b "TI-89 emulation enabled",0
disable89emu dc.b "TI-89 emulation disabled",0

AboutDialog    dc.l $000B0014,$00C00064,$00060006,amsg1,$00060011,amsg2
               dc.l $0006001c,amsg3,$00060029,amsg4,$00060034,amsg5
               dc.l $0006003f,amsg6,0

amsg1 dc.b "[tie] Browser 0.3",0
amsg2 dc.b "by Rusty Wagner and",0
amsg3 dc.b "MXM-TriX for [tie]",0
amsg4 dc.b "Get new version from",0
amsg5 dc.b "--------------------",0
amsg6 dc.b "http://mxm.ticalc.org",0
	       		
overrideDialog dc.l $000B0014,$00B50066,$00060006,ovrtext1,$00060016,ovrtext2
               dc.l $00060026,ovrtext3,$00060036,ovrtext4,$00060046,ovrtext5
               dc.l $00060056,ovrtext6,0

ovrtext1 dc.b "This program was not",0
ovrtext2 dc.b "designed to run on",0
ovrtext3 dc.b "the TI-89 and may",0
ovrtext4 dc.b "cause problems.  Do",0
ovrtext5 dc.b "you want to continue?",0
ovrtext6 dc.b "[Enter]=Yes [ESC]=No",0

notcompatDialog dc.l $000B0018,$0095004C,$00060006,nctext1,$0006000E,nctext2
                dc.l $00060016,nctext3,$0006001E,nctext4,$00060026,nctext5,0
nctext1 dc.b "This program was",0
nctext2 dc.b "compiled for an older",0
nctext3 dc.b "version of PlusShell",0
nctext4 dc.b "and will not run on",0
nctext5 dc.b "this version.",0

warn89emuDialog dc.l $001E001C,$00D20064,$00060006,emutext1,$00060010,emutext2
                dc.l $0006001A,emutext3,$00060024,emutext4,$0006002E,emutext5
                dc.l $00060038,emutext6,0
emutext1 dc.b "This program was not",0
emutext2 dc.b "designed to run on",0
emutext3 dc.b "the TI-92+ and may",0
emutext4 dc.b "cause problems.  Do",0
emutext5 dc.b "you want to continue?",0
emutext6 dc.b "[Enter]=Yes [ESC]=No",0

;fargoLibMsg dc.b "Fargo II Lib - Run to convert",0

        BSS
handlelist ds.w 128
handlecount ds.l 1
oldVect ds.b $4c
errorStack ds.l 1
newROMTable ds.l 684
oldROMTable ds.l 1
OldHandleB ds.l 1
OldHandleC ds.l 1
flags ds.w 1

        end
